## mupen64plus-rsp-hle 1.99.4+26+8fd36d9bc293

=== projects/unix/Makefile ===
#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
# *   mupen64plus-rsp-hle - Makefile                                        *
# *   Mupen64Plus homepage: http://code.google.com/p/mupen64plus/           *
# *   Copyright (C) 2008-2009 Richard Goedeken                              *
# *   Copyright (C) 2007-2008 DarkJeztr Tillin9                             *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
# * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
# Makefile for Mupen64 HLE RSP plugin in Mupen64plus.

# detect operating system
UNAME = $(shell uname -s)
OS := NONE
ifeq ("$(UNAME)","Linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","linux")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifneq ("$(filter GNU hurd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","Darwin")
  OS = OSX
  SO_EXTENSION = dylib
  SHARED = -bundle
endif
ifeq ("$(UNAME)","FreeBSD")
  OS = FREEBSD
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(UNAME)","OpenBSD")
  OS = FREEBSD
  SO_EXTENSION = so
  SHARED = -shared
  $(warning OS type "$(UNAME)" not officially supported.')
endif
ifneq ("$(filter GNU/kFreeBSD kfreebsd,$(UNAME))","")
  OS = LINUX
  SO_EXTENSION = so
  SHARED = -shared
endif
ifeq ("$(OS)","NONE")
  $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# detect system architecture
HOST_CPU ?= $(shell uname -m)
NO_ASM ?= 1
CPU := NONE
ifneq ("$(filter x86_64 amd64,$(HOST_CPU))","")
  CPU := X86
  ifeq ("$(BITS)", "32")
    ARCH_DETECTED := 64BITS_32
    PIC ?= 0
  else
    ARCH_DETECTED := 64BITS
    PIC ?= 1
  endif
endif
ifneq ("$(filter pentium i%86,$(HOST_CPU))","")
  CPU := X86
  ARCH_DETECTED := 32BITS
  PIC ?= 0
endif
ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 32BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.')
endif
ifneq ("$(filter ppc64 powerpc64,$(HOST_CPU))","")
  CPU := PPC
  ARCH_DETECTED := 64BITS
  BIG_ENDIAN := 1
  PIC ?= 1
  $(warning Architecture "$(HOST_CPU)" not officially supported.')
endif
ifeq ("$(CPU)","NONE")
  $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
endif

# base CFLAGS, LDLIBS, and LDFLAGS
OPTFLAGS ?= -O3
CFLAGS += $(OPTFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
CXXFLAGS += -fvisibility-inlines-hidden
LDFLAGS += $(SHARED)

# Since we are building a shared library, we must compile with -fPIC on some architectures
# On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
ifeq ($(PIC), 1)
  CFLAGS += -fPIC
  LDFLAGS += -fPIC
else
  CFLAGS += -fno-PIC
  LDFLAGS += -fno-PIC
endif

ifeq ($(BIG_ENDIAN), 1)
  CFLAGS += -DM64P_BIG_ENDIAN
endif

# tweak flags for 32-bit build on 64-bit system
ifeq ($(ARCH_DETECTED), 64BITS_32)
  ifeq ($(OS), FREEBSD)
    $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
  endif
  CFLAGS += -m32
  LDFLAGS += -m32 -Wl,-m,elf_i386
endif

# set special flags per-system
ifeq ($(OS), LINUX)
  # only export api symbols
  LDFLAGS += -Wl,-version-script,$(SRCDIR)/rsp_api_export.ver
endif
ifeq ($(OS), OSX)
  ifeq ($(CPU), X86)
    ifeq ($(ARCH_DETECTED), 64BITS)
      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
      LDFLAGS += -arch x86_64
    else
      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
      LDFLAGS += -arch i686
    endif
  endif
endif

# set mupen64plus core API header path
ifneq ("$(APIDIR)","")
  CFLAGS += "-I$(APIDIR)"
else
  TRYDIR = ../../../mupen64plus-core/src/api
  ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
    CFLAGS += -I$(TRYDIR)
  else
    TRYDIR = /usr/local/include/mupen64plus
    ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
      CFLAGS += -I$(TRYDIR)
    else
      TRYDIR = /usr/include/mupen64plus
      ifneq ("$(wildcard $(TRYDIR)/m64p_types.h)","")
        CFLAGS += -I$(TRYDIR)
      else
        $(error Mupen64Plus API header files not found! Use makefile parameter APIDIR to force a location.)
      endif
    endif
  endif
endif

# reduced compile output when running make without V=1
ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
	Q_CC  = @echo '    CC  '$@;
	Q_CXX = @echo '    CXX '$@;
	Q_LD  = @echo '    LD  '$@;
endif
endif

# set base program pointers and flags
CC       ?= gcc
CXX      ?= g++
RM       ?= rm -f
INSTALL  ?= install
MKDIR ?= mkdir -p
COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.o = $(Q_LD)$(CXX) $(LDFLAGS) $(TARGET_ARCH)

# set special flags for given Makefile parameters
ifeq ($(DEBUG),1)
  CFLAGS += -g
  INSTALL_STRIP_FLAG ?= 
else
  INSTALL_STRIP_FLAG ?= -s
endif

# set installation options
ifeq ($(PREFIX),)
  PREFIX := /usr/local
endif
ifeq ($(LIBDIR),)
  LIBDIR := $(PREFIX)/lib
endif
ifeq ($(PLUGINDIR),)
  PLUGINDIR := $(LIBDIR)/mupen64plus
endif

SRCDIR = ../../src
OBJDIR = _obj

# list of source files to compile
SOURCE = \
	$(SRCDIR)/main.c \
	$(SRCDIR)/jpeg.c \
	$(SRCDIR)/ucode3.cpp \
	$(SRCDIR)/ucode2.cpp \
	$(SRCDIR)/ucode1.cpp \
	$(SRCDIR)/ucode3mp3.cpp

# generate a list of object files build, make a temporary directory for them
OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
OBJECTS += $(patsubst $(SRCDIR)/%.cpp, $(OBJDIR)/%.o, $(filter %.cpp, $(SOURCE)))
OBJDIRS = $(dir $(OBJECTS))
$(shell $(MKDIR) $(OBJDIRS))

# build targets
TARGET = mupen64plus-rsp-hle.$(SO_EXTENSION)

targets:
	@echo "Mupen64Plus-rsp-hle makefile. "
	@echo "  Targets:"
	@echo "    all           == Build Mupen64Plus rsp-hle plugin"
	@echo "    clean         == remove object files"
	@echo "    rebuild       == clean and re-build all"
	@echo "    install       == Install Mupen64Plus rsp-hle plugin"
	@echo "    uninstall     == Uninstall Mupen64Plus rsp-hle plugin"
	@echo "  Options:"
	@echo "    BITS=32       == build 32-bit binaries on 64-bit machine"
	@echo "    APIDIR=path   == path to find Mupen64Plus Core headers"
	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3)"
	@echo "    PIC=(1|0)     == Force enable/disable of position independent code"
	@echo "  Install Options:"
	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
	@echo "    PLUGINDIR=path == path to install plugin libraries (default: LIBDIR/mupen64plus)"
	@echo "    DESTDIR=path  == path to prepend to all installation paths (only for packagers)"
	@echo "  Debugging Options:"
	@echo "    DEBUG=1       == add debugging symbols"
	@echo "    V=1           == show verbose compiler output"

all: $(TARGET)

install: $(TARGET)
	$(INSTALL) -d "$(DESTDIR)$(PLUGINDIR)"
	$(INSTALL) -m 0644 $(INSTALL_STRIP_FLAG) $(TARGET) "$(DESTDIR)$(PLUGINDIR)"

uninstall:
	$(RM) "$(DESTDIR)$(PLUGINDIR)/$(TARGET)"

clean:
	$(RM) -r ./_obj $(TARGET)

rebuild: clean all

# build dependency files
CFLAGS += -MD
-include $(OBJECTS:.o=.d)

CXXFLAGS += $(CFLAGS)

# standard build rules
$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(COMPILE.c) -o $@ $<

$(OBJDIR)/%.o: $(SRCDIR)/%.cpp
	$(COMPILE.cc) -o $@ $<

$(TARGET): $(OBJECTS)
	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@

.PHONY: all clean install uninstall targets

## mupen64plus-rsp-hle 1.99.4

=== debian/changelog ===
mupen64plus-rsp-hle (1.99.4-4) unstable; urgency=low

  * debian/control:
    - Add virtual package libsdl-dev as alternative build dependency
  * Don't mix implicit and explicit rules to prevent FTBFS with make
    3.82
  * Remove hardening-includes which are now integrated in dpkg-
    buildflags
  * Use debian packaging manual URL as format identifier in
    debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Mon, 31 Oct 2011 12:49:14 +0100

mupen64plus-rsp-hle (1.99.4-3) unstable; urgency=low

  * Upload to unstable
  * debian/rules:
    - Mark all targets as phony
    - Force PIC using Makefile option
    - Remove unintended optimization flags
  * debian/patches:
    - Remove obsolete default-optimisations.patch, hurd_os.patch
    - Add rewrite_makefile.patch, Rewrite Makefile to fix flags and
      linking
    - Add big_endian_conflict.patch, Don't use _BIG_ENDIAN to check for
      endianness
    - Add endianness_xor.patch, Add parentheses around arithmetic in
      operand of ‘^’ related to endian conversation

 -- Sven Eckelmann <sven@narfation.org>  Sun, 24 Jul 2011 14:24:01 +0200

mupen64plus-rsp-hle (1.99.4-2) experimental; urgency=low

  * Upgraded to policy 3.9.2, no changes required
  * Update Vcs-* fields to new anonscm.debian.org URLs in debian/control
  * Add multiarch support

 -- Sven Eckelmann <sven@narfation.org>  Sat, 11 Jun 2011 16:52:39 +0200

mupen64plus-rsp-hle (1.99.4-1) experimental; urgency=low

  * New Upstream Version
  * Updated my maintainer e-mail address
  * Split source package to match upstreams modular release packages
  * debian/copyright:
    - Update to DEP5 revision 164
    - Update copyright years
  * debian/patches:
    - Add hurd_os.patch, Add GNU/Hurd as operating system with "linux"
      userland
    - Rebase default-optimisations.patch against 1.99.4
    - Remove upstream merged patches: as-needed.patch,
      correct_fpr32_mapping.patch, correct_security_printf.patch,
      debian-archs.patch, dejavu-font.patch, destdir.patch,
      dont-install-unneeded.patch, fix-7z-subfolder.patch,
      fix-desktop-file.patch, fix_r0_override.patch, fix_readpng.patch,
      ftbfs-debugger.patch, ftbfs-dynarec.patch, ftbfs-glibc210.patch,
      ftbfs-gvariant-type-conflicts.patch, ftbfs-kfreebsd.patch,
      glide64_hurd.patch, glide64-noasm.patch, gtk-open-filter.patch,
      interpreter_x86_fldcw.patch, jttl_fix_romclosed.patch,
      link_gdk.patch, load_aidacrate.patch, load_vistatus.patch,
      noexecstack.patch, optional_signinfo.patch, osd-pause-crash.patch,
      path_max.patch, pie_support.patch, plugin-searchpath.patch,
      remove-gln64.patch, remove-nondfsg-icons.patch,
      resume_on_start.patch, rice-ati-symbols.patch,
      rice-crash-vendorstring.patch, rice_fog.patch, rice_nodebug.patch,
      rice-screenflickering.patch, rice-texturepack-crash.patch,
      rsp_hle_bigendian.patch, rsp_ucode2_reset.patch,
      static-binutils-libs.patch, system-libbz2.patch,
      system-liblzma.patch, system-libpng.patch, system-zlib.patch,
      version-string.patch, xdg-basedir.patch

 -- Sven Eckelmann <sven@narfation.org>  Sat, 22 Jan 2011 11:05:28 +0100

mupen64plus (1.5+dfsg1-14) experimental; urgency=low

  * Upgraded to policy 3.9.1, no changes required
  * Upgrade debhelper compat to v8
  * debian/rules:
    - set *FLAGS using dpkg-buildflags in debian/rules to work like
      dpkg-buildpackage when called directly
    - Use hardening-includes for CFLAGS and LDFLAGS hardened builds
    - Use externally provided LDFLAGS
    - Disable support for debugger due to missing pic/pie support of
      libopcodes.a
  * debian/patches:
    - Add correct_security_printf.patch, Correct possible printf format
      string vulnerability
    - Add pie_support.patch, Add support for PIE/PIC

 -- Sven Eckelmann <sven@narfation.org>  Thu, 23 Sep 2010 13:52:32 +0200

mupen64plus (1.5+dfsg1-13) unstable; urgency=low

  * debian/patches:
    - Add path_max.patch, Add dummy PATH_MAX on systems without it
      (Closes: #588066)
    - Add optional_signinfo.patch, Only use siginfo subsystem if system
      offers it (Closes: #588066)
    - Add glide64_hurd.patch, Define GNU/Hurd as UNIX system for glide64
      (Closes: #588066)

 -- Sven Eckelmann <sven@narfation.org>  Mon, 12 Jul 2010 23:20:02 +0200

mupen64plus (1.5+dfsg1-12) unstable; urgency=low

  * Use googlecode.debian.net instead of complex own filters for
    debian/watch
  * Upgraded to policy 3.9.0, no changes required
  * Build only on i386/amd64 because upstream doesn't to support more
  * debian/patches:
    - Add link_gdk.patch, Link directly against gdk-2.0 instead
      indirectly through gtk+-2.0

 -- Sven Eckelmann <sven@narfation.org>  Mon, 28 Jun 2010 21:31:48 +0200

mupen64plus (1.5+dfsg1-11) unstable; urgency=low

  * debian/patches:
    - Rename ftbfs-gvariant-type-conflicts.path to
      ftbfs-gvariant-type-conflicts.patch
    - Add rice-ati-symbols.patch, Allow to load rice on systems with
      missing opengl extensions

 -- Sven Eckelmann <sven@narfation.org>  Sun, 23 May 2010 11:55:23 +0200

mupen64plus (1.5+dfsg1-10) unstable; urgency=low

  [ Sven Eckelmann ]
  * debian/patches:
    - Add rsp_ucode2_reset.patch, Reset status of specific ucode2 hacks
      after starting again
    - Add rsp_hle_bigendian.patch, Fix wrong high level emulation of rsp
      on big endian systems
    - Add rice-crash-vendorstring.patch, Don't crash on long OpenGL
      vendor string (Closes: #580480, LP: #575968)

  [ Piotr Ożarowski ]
  * DMUA flag set to yes

 -- Sven Eckelmann <sven@narfation.org>  Thu, 06 May 2010 11:34:46 +0200

mupen64plus (1.5+dfsg1-9) unstable; urgency=low

  * debian/patches:
    - Add ftbfs-gvariant-type-conflicts.path, Fix FTBFS due to glib's
      gvariant.h type definitions (Closes: #577329)
    - Add dont-install-unneeded.patch, Don't install files which aren't
      used by us
  * debian/rules:
    - Enable parallel builds using dh's --parallel


=== debian/control ===
Source: mupen64plus-rsp-hle
Section: games
Priority: optional
Maintainer: Tobias Loose <TobiasLoose@gmx.de>
Uploaders: Sven Eckelmann <sven@narfation.org>
DM-Upload-Allowed: yes
Standards-Version: 3.9.2
Homepage: http://code.google.com/p/mupen64plus/
Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-rsp-hle.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-rsp-hle.git
Build-Depends:
 debhelper (>= 8.1.3),
 dpkg-dev (>= 1.16.0),
 libmupen64plus-dev,
 libsdl1.2-dev | libsdl-dev,

Package: mupen64plus-rsp-hle
Architecture: any-i386 any-amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mupen64plus-rsp-abi-1,
Provides:
 mupen64plus-rsp,
Description: high-level rsp emulation for mupen64plus
 N64 Reality Signal Processor function level emulation for graphics plugins
 supporting vertex processing by their own. It supports memory and register
 initialisation, audio and display lists processing including jpeg and mp3
 decoding for common microcodes.

Package: mupen64plus-rsp-hle-dbg
Section: debug
Priority: extra
Architecture: any-i386 any-amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 mupen64plus-rsp-hle (= ${binary:Version}),
Description: high-level rsp emulation for mupen64plus debug symbols package
 N64 Reality Signal Processor function level emulation for graphics plugins
 supporting vertex processing by their own. It supports memory and register
 initialisation, audio and display lists processing including jpeg and mp3
 decoding for common microcodes.
 .
 This package contains the debug files.

## mupen64plus-rsp-hle 1.99.4+26+8fd36d9bc293

=== debian/changelog ===
mupen64plus-rsp-hle (1.99.4+26+8fd36d9bc293-1) experimental; urgency=low

  * New upstream snapshot from revision 8fd36d9bc2938825a34c1f9758cf95926ce697a9

 -- Sven Eckelmann <sven@narfation.org>  Sat, 12 Nov 2011 21:42:34 +0100

mupen64plus-rsp-hle (1.99.4+23+850d9527e48e-1) experimental; urgency=low

  * New upstream snapshot from revision 850d9527e48eb08a9c2d57d97b68b79bef46940e
  * debian/control:
    - Depend on mupen64plus-*-abi-2
    - Build-Depend on libmupen64plus-dev >= 1.99.4+77+8bb0e6b3ae3a-1
  * Don't mix implicit and explicit rules to prevent FTBFS with make 3.82
  * debian/patches:
    - Remove upstream merged patches big_endian_conflict.patch,
      endianness_xor.patch, rewrite_makefile.patch
  * Add debian/get-orig-source.sh for snapshots

 -- Sven Eckelmann <sven@narfation.org>  Mon, 29 Aug 2011 17:05:53 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Build-Depends:
  debhelper (>= 8.1.3),
  dpkg-dev (>= 1.16.0),
- libmupen64plus-dev,
+ libmupen64plus-dev (>= 1.99.4+77+8bb0e6b3ae3a),
  libsdl1.2-dev | libsdl-dev,
 
 Package: mupen64plus-rsp-hle
@@ -22,7 +22,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- mupen64plus-rsp-abi-1,
+ mupen64plus-rsp-abi-2,
 Provides:
  mupen64plus-rsp,
 Description: high-level rsp emulation for mupen64plus

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

LDFLAGS += -Wl,--as-needed

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS=""

DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing

get-orig-source:
	$(CURDIR)/debian/get-orig-source.sh

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_strip:
	dh_strip -a --dbg-package="$(DBG_PACKAGE)"

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	get-orig-source override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_installchangelogs

## mupen64plus-rsp-hle 1.99.5

=== projects/unix/Makefile ===
--- 
+++ 
@@ -214,6 +214,7 @@
 SOURCE = \
 	$(SRCDIR)/main.c \
 	$(SRCDIR)/jpeg.c \
+	$(SRCDIR)/idct.c \
 	$(SRCDIR)/ucode3.cpp \
 	$(SRCDIR)/ucode2.cpp \
 	$(SRCDIR)/ucode1.cpp \

=== debian/changelog ===
mupen64plus-rsp-hle (1.99.5-3) unstable; urgency=low

  * debian/patches:
    - Add gcc_lto.patch, Enable support for link-time optimization

 -- Sven Eckelmann <sven@narfation.org>  Sat, 09 Jun 2012 00:59:47 +0200

mupen64plus-rsp-hle (1.99.5-2) unstable; urgency=low

  [ Simon Ruderich ]
  * Let debhelper set the buildflags implicitly

  [ Sven Eckelmann ]
  * debian/patches:
    - Add pokemon_stadium_sound.patch, Fix sound in pokemon stadium
    - Add zelda_graphics_glitches.patch, Fix graphics glitches in Zelda OOT

 -- Sven Eckelmann <sven@narfation.org>  Fri, 27 Apr 2012 11:37:33 +0200

mupen64plus-rsp-hle (1.99.5-1) unstable; urgency=low

  * New Upstream Version
  * Update debian/copyright
  * Enable all hardening flags in debian/rules
  * Upgraded to policy 3.9.3, no changes required
  * Upgrade debhelper compat to v9
  * Use buildflags.mk to set security flags in debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Sat, 17 Mar 2012 20:18:35 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,18 +1,13 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
-export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
-export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
-export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
+export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-
-LDFLAGS += -Wl,--as-needed
-
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
-MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS=""
+MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="" LTO=1
 
 DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

=== debian/watch ===
version=3

http://bitbucket.org/richard42/mupen64plus-rsp-hle/downloads/ \
	/richard42/mupen64plus-rsp-hle/downloads/mupen64plus-rsp-hle-src-(.*).tar.gz

## mupen64plus-rsp-hle 2.0

=== projects/unix/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 # Makefile for Mupen64 HLE RSP plugin in Mupen64plus.
 
 # detect operating system
-UNAME = $(shell uname -s)
+UNAME ?= $(shell uname -s)
 OS := NONE
 ifeq ("$(UNAME)","Linux")
   OS = LINUX
@@ -59,6 +59,12 @@
   OS = LINUX
   SO_EXTENSION = so
   SHARED = -shared
+endif
+ifeq ("$(patsubst MINGW%,MINGW,$(UNAME))","MINGW")
+  OS = MINGW
+  SO_EXTENSION = dll
+  SHARED = -shared
+  PIC = 0
 endif
 ifeq ("$(OS)","NONE")
   $(error OS type "$(UNAME)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
@@ -83,7 +89,7 @@
   ARCH_DETECTED := 32BITS
   PIC ?= 0
 endif
-ifneq ("$(filter ppc powerpc,$(HOST_CPU))","")
+ifneq ("$(filter ppc macppc socppc powerpc,$(HOST_CPU))","")
   CPU := PPC
   ARCH_DETECTED := 32BITS
   BIG_ENDIAN := 1
@@ -97,13 +103,22 @@
   PIC ?= 1
   $(warning Architecture "$(HOST_CPU)" not officially supported.')
 endif
+ifneq ("$(filter arm%,$(HOST_CPU))","")
+  ifeq ("$(filter arm%b,$(HOST_CPU))","")
+    CPU := ARM
+    ARCH_DETECTED := 32BITS
+    PIC ?= 1
+    $(warning Architecture "$(HOST_CPU)" not officially supported.')
+  endif
+endif
 ifeq ("$(CPU)","NONE")
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
 endif
 
 # base CFLAGS, LDLIBS, and LDFLAGS
-OPTFLAGS ?= -O3
-CFLAGS += $(OPTFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
+OPTFLAGS ?= -O3 -flto
+WARNFLAGS ?= -Wall
+CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
 CXXFLAGS += -fvisibility-inlines-hidden
 LDFLAGS += $(SHARED)
 
@@ -111,10 +126,8 @@
 # On 32-bit x86 systems we do not want to use -fPIC because we don't have to and it has a big performance penalty on this arch
 ifeq ($(PIC), 1)
   CFLAGS += -fPIC
-  LDFLAGS += -fPIC
 else
   CFLAGS += -fno-PIC
-  LDFLAGS += -fno-PIC
 endif
 
 ifeq ($(BIG_ENDIAN), 1)
@@ -127,7 +140,7 @@
     $(error Do not use the BITS=32 option with FreeBSD, use -m32 and -m elf_i386)
   endif
   CFLAGS += -m32
-  LDFLAGS += -m32 -Wl,-m,elf_i386
+  LDFLAGS += -Wl,-m,elf_i386
 endif
 
 # set special flags per-system
@@ -136,13 +149,24 @@
   LDFLAGS += -Wl,-version-script,$(SRCDIR)/rsp_api_export.ver
 endif
 ifeq ($(OS), OSX)
+  # Select the proper SDK
+  # Also, SDKs are stored in a different location since XCode 4.3
+  OSX_SDK ?= $(shell sw_vers -productVersion | cut -f1 -f2 -d .)
+  OSX_XCODEMAJ = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f1 -d .)
+  OSX_XCODEMIN = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f2 -d .)
+  OSX_XCODEGE43 = $(shell echo "`expr $(OSX_XCODEMAJ) \>= 4``expr $(OSX_XCODEMIN) \>= 3`")
+  ifeq ($(OSX_XCODEGE43), 11)
+    OSX_SYSROOT := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs
+  else
+    OSX_SYSROOT := /Developer/SDKs
+  endif
+
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
-      LDFLAGS += -arch x86_64
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
     else
-      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot /Developer/SDKs/MacOSX10.5.sdk
-      LDFLAGS += -arch i686
+      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
+      LDFLAGS += -read_only_relocs suppress
     endif
   endif
 endif
@@ -179,21 +203,23 @@
 endif
 
 # set base program pointers and flags
-CC       ?= gcc
-CXX      ?= g++
+CC        = $(CROSS_COMPILE)gcc
+CXX       = $(CROSS_COMPILE)g++
 RM       ?= rm -f
 INSTALL  ?= install
 MKDIR ?= mkdir -p
 COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
 COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
-LINK.o = $(Q_LD)$(CXX) $(LDFLAGS) $(TARGET_ARCH)
+LINK.o = $(Q_LD)$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TARGET_ARCH)
 
 # set special flags for given Makefile parameters
 ifeq ($(DEBUG),1)
   CFLAGS += -g
   INSTALL_STRIP_FLAG ?= 
 else
-  INSTALL_STRIP_FLAG ?= -s
+  ifneq ($(OS),OSX)
+    INSTALL_STRIP_FLAG ?= -s
+  endif
 endif
 
 # set installation options
@@ -208,13 +234,14 @@
 endif
 
 SRCDIR = ../../src
-OBJDIR = _obj
+OBJDIR = _obj$(POSTFIX)
 
 # list of source files to compile
 SOURCE = \
 	$(SRCDIR)/main.c \
+	$(SRCDIR)/alist.c \
+	$(SRCDIR)/cicx105.c \
 	$(SRCDIR)/jpeg.c \
-	$(SRCDIR)/idct.c \
 	$(SRCDIR)/ucode3.cpp \
 	$(SRCDIR)/ucode2.cpp \
 	$(SRCDIR)/ucode1.cpp \
@@ -227,7 +254,7 @@
 $(shell $(MKDIR) $(OBJDIRS))
 
 # build targets
-TARGET = mupen64plus-rsp-hle.$(SO_EXTENSION)
+TARGET = mupen64plus-rsp-hle$(POSTFIX).$(SO_EXTENSION)
 
 targets:
 	@echo "Mupen64Plus-rsp-hle makefile. "
@@ -240,8 +267,10 @@
 	@echo "  Options:"
 	@echo "    BITS=32       == build 32-bit binaries on 64-bit machine"
 	@echo "    APIDIR=path   == path to find Mupen64Plus Core headers"
-	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3)"
+	@echo "    OPTFLAGS=flag == compiler optimization (default: -O3 -flto)"
+	@echo "    WARNFLAGS=flag == compiler warning levels (default: -Wall)"
 	@echo "    PIC=(1|0)     == Force enable/disable of position independent code"
+	@echo "    POSTFIX=name  == String added to the name of the the build (default: '')"
 	@echo "  Install Options:"
 	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
 	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
@@ -261,7 +290,7 @@
 	$(RM) "$(DESTDIR)$(PLUGINDIR)/$(TARGET)"
 
 clean:
-	$(RM) -r ./_obj $(TARGET)
+	$(RM) -r $(OBJDIR) $(TARGET)
 
 rebuild: clean all

=== debian/changelog ===
mupen64plus-rsp-hle (2.0-1) unstable; urgency=low

  * New Upstream Version
  * Upload to unstable
  * debian/control:
    - Build-Depend on debhelper 9.20130604 for support of parameters when
      detecting targets in dh_auto_*
  * debian/rules:
    - Work around new debhelper 9.20130624 dh_auto_{clean,test} behavior
      which is causing a FTBFS by adding an explicit
      override_dh_auto_{clean,test} rule
  * debian/watch:
    - Verify new upstream versions using GPG key 954F81B094AA5BB226F5

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Jul 2013 22:53:00 +0200

mupen64plus-rsp-hle (2.0~rc2+1+3d76355d095c-2) experimental; urgency=low

  * Remove unused dependency to libsdl1.2-dev in debian/control
  * Update debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Sun, 23 Jun 2013 13:25:17 +0200

mupen64plus-rsp-hle (2.0~rc2+1+3d76355d095c-1) experimental; urgency=low

  * New Upstream Snapshot from 3d76355d095c456eb32677cb65feb775ef24d896
  * Enable link-time optimization in debian/rules similar to upstream

 -- Sven Eckelmann <sven@narfation.org>  Wed, 05 Jun 2013 13:25:15 +0200

mupen64plus-rsp-hle (1.99.5+25+a77acef394fd-1) experimental; urgency=low

  * New Upstream Snapshot from a77acef394fdc331160e0e583b4f45f557b1b97c
  * Disable extra debug code in release builds with -DNDEBUG in
    debian/rules

 -- Sven Eckelmann <sven@narfation.org>  Fri, 08 Feb 2013 10:15:39 +0100

mupen64plus-rsp-hle (1.99.5+11+bf4a5b4315de-1) experimental; urgency=low

  * New Upstream Snapshot from bf4a5b4315de9214efde317b2f3c9367880c9d8f
  * Upgraded to policy 3.9.4, no changes required
  * Remove obsolete DM-Upload-Allowed in debian/control

 -- Sven Eckelmann <sven@narfation.org>  Sun, 02 Dec 2012 22:32:24 +0100

mupen64plus-rsp-hle (1.99.5+8+1e306f08d231-1) experimental; urgency=low

  * New Upstream Snapshot from 1e306f08d231ffc677723e93a4b84a3ba7503058

 -- Sven Eckelmann <sven@narfation.org>  Tue, 11 Sep 2012 21:21:51 +0200

mupen64plus-rsp-hle (1.99.5+6+0d5a734e9425-1) experimental; urgency=low

  * New Upstream Snapshot from 0d5a734e942501a78d199d53ad0099ce87855d3a
  * debian/patches:
    - Remove upstream merged gcc_lto.patch, pokemon_stadium_sound.patch
       zelda_graphics_glitches.patch

 -- Sven Eckelmann <sven@narfation.org>  Sun, 17 Jun 2012 00:51:47 +0200

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,14 @@
 Priority: optional
 Maintainer: Tobias Loose <TobiasLoose@gmx.de>
 Uploaders: Sven Eckelmann <sven@narfation.org>
-DM-Upload-Allowed: yes
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://code.google.com/p/mupen64plus/
 Vcs-Git: git://anonscm.debian.org/collab-maint/mupen64plus-rsp-hle.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/mupen64plus-rsp-hle.git
 Build-Depends:
- debhelper (>= 8.1.3),
- dpkg-dev (>= 1.16.0),
- libmupen64plus-dev (>= 1.99.4+77+8bb0e6b3ae3a),
- libsdl1.2-dev | libsdl-dev,
+ debhelper (>= 9.20130604),
+ dpkg-dev (>= 1.16.1.1),
+ libmupen64plus-dev (>= 1.99.5),
 
 Package: mupen64plus-rsp-hle
 Architecture: any-i386 any-amd64

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-flto
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG"

DBG_PACKAGE=$(shell dpkg-parsechangelog|grep '^Source: '|sed 's/^Source:\s*//')-dbg

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix" --parallel --list-missing

get-orig-source:
	$(CURDIR)/debian/get-orig-source.sh

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_strip:
	dh_strip -a --dbg-package="$(DBG_PACKAGE)"

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	get-orig-source override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_strip override_dh_installchangelogs

=== debian/watch ===
version=3

opts="pgpsigurlmangle=s/$/.asc/" \
 http://bitbucket.org/richard42/mupen64plus-rsp-hle/downloads/ \
	/richard42/mupen64plus-rsp-hle/downloads/mupen64plus-rsp-hle-src-(.*).tar.gz

## mupen64plus-rsp-hle 2.5

=== projects/unix/Makefile ===
--- 
+++ 
@@ -111,6 +111,12 @@
     $(warning Architecture "$(HOST_CPU)" not officially supported.')
   endif
 endif
+ifneq ("$(filter mips,$(HOST_CPU))","")
+  CPU := MIPS
+  ARCH_DETECTED := 32BITS
+  PIC ?= 1
+  $(warning Architecture "$(HOST_CPU)" not officially supported.')
+endif
 ifeq ("$(CPU)","NONE")
   $(error CPU type "$(HOST_CPU)" not supported.  Please file bug report at 'http://code.google.com/p/mupen64plus/issues')
 endif
@@ -119,7 +125,6 @@
 OPTFLAGS ?= -O3 -flto
 WARNFLAGS ?= -Wall
 CFLAGS += $(OPTFLAGS) $(WARNFLAGS) -ffast-math -fno-strict-aliasing -fvisibility=hidden -I../../src
-CXXFLAGS += -fvisibility-inlines-hidden
 LDFLAGS += $(SHARED)
 
 # Since we are building a shared library, we must compile with -fPIC on some architectures
@@ -149,23 +154,15 @@
   LDFLAGS += -Wl,-version-script,$(SRCDIR)/rsp_api_export.ver
 endif
 ifeq ($(OS), OSX)
-  # Select the proper SDK
-  # Also, SDKs are stored in a different location since XCode 4.3
-  OSX_SDK ?= $(shell sw_vers -productVersion | cut -f1 -f2 -d .)
-  OSX_XCODEMAJ = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f1 -d .)
-  OSX_XCODEMIN = $(shell xcodebuild -version | grep '[0-9]*\.[0-9]*' | cut -f2 -d ' ' | cut -f2 -d .)
-  OSX_XCODEGE43 = $(shell echo "`expr $(OSX_XCODEMAJ) \>= 4``expr $(OSX_XCODEMIN) \>= 3`")
-  ifeq ($(OSX_XCODEGE43), 11)
-    OSX_SYSROOT := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs
-  else
-    OSX_SYSROOT := /Developer/SDKs
-  endif
+  #xcode-select has been around since XCode 3.0, i.e. OS X 10.5
+  OSX_SDK_ROOT = $(shell xcode-select -print-path)/Platforms/MacOSX.platform/Developer/SDKs
+  OSX_SDK_PATH = $(OSX_SDK_ROOT)/$(shell ls $(OSX_SDK_ROOT) | tail -1)
 
   ifeq ($(CPU), X86)
     ifeq ($(ARCH_DETECTED), 64BITS)
-      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
+      CFLAGS += -pipe -arch x86_64 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
     else
-      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=$(OSX_SDK) -isysroot $(OSX_SYSROOT)/MacOSX$(OSX_SDK).sdk
+      CFLAGS += -pipe -mmmx -msse -fomit-frame-pointer -arch i686 -mmacosx-version-min=10.5 -isysroot $(OSX_SDK_PATH)
       LDFLAGS += -read_only_relocs suppress
     endif
   endif
@@ -197,20 +194,17 @@
 ifneq ($(findstring $(MAKEFLAGS),s),s)
 ifndef V
 	Q_CC  = @echo '    CC  '$@;
-	Q_CXX = @echo '    CXX '$@;
 	Q_LD  = @echo '    LD  '$@;
 endif
 endif
 
 # set base program pointers and flags
 CC        = $(CROSS_COMPILE)gcc
-CXX       = $(CROSS_COMPILE)g++
 RM       ?= rm -f
 INSTALL  ?= install
 MKDIR ?= mkdir -p
 COMPILE.c = $(Q_CC)$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
-COMPILE.cc = $(Q_CXX)$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
-LINK.o = $(Q_LD)$(CXX) $(CXXFLAGS) $(LDFLAGS) $(TARGET_ARCH)
+LINK.o = $(Q_LD)$(CC) $(CFLAGS) $(LDFLAGS) $(TARGET_ARCH)
 
 # set special flags for given Makefile parameters
 ifeq ($(DEBUG),1)
@@ -233,23 +227,32 @@
   PLUGINDIR := $(LIBDIR)/mupen64plus
 endif
 
+# enable/disable task dumping support
+ifeq ($(DUMP), 1)
+	CFLAGS += -DENABLE_TASK_DUMP
+endif
+
+
 SRCDIR = ../../src
 OBJDIR = _obj$(POSTFIX)
 
 # list of source files to compile
 SOURCE = \
-	$(SRCDIR)/main.c \
 	$(SRCDIR)/alist.c \
+	$(SRCDIR)/alist_audio.c \
+	$(SRCDIR)/alist_naudio.c \
+	$(SRCDIR)/alist_nead.c \
+	$(SRCDIR)/audio.c \
 	$(SRCDIR)/cicx105.c \
+	$(SRCDIR)/hle.c \
 	$(SRCDIR)/jpeg.c \
-	$(SRCDIR)/ucode3.cpp \
-	$(SRCDIR)/ucode2.cpp \
-	$(SRCDIR)/ucode1.cpp \
-	$(SRCDIR)/ucode3mp3.cpp
+	$(SRCDIR)/memory.c \
+	$(SRCDIR)/mp3.c \
+	$(SRCDIR)/musyx.c \
+	$(SRCDIR)/plugin.c
 
 # generate a list of object files build, make a temporary directory for them
 OBJECTS := $(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(filter %.c, $(SOURCE)))
-OBJECTS += $(patsubst $(SRCDIR)/%.cpp, $(OBJDIR)/%.o, $(filter %.cpp, $(SOURCE)))
 OBJDIRS = $(dir $(OBJECTS))
 $(shell $(MKDIR) $(OBJDIRS))
 
@@ -271,6 +274,7 @@
 	@echo "    WARNFLAGS=flag == compiler warning levels (default: -Wall)"
 	@echo "    PIC=(1|0)     == Force enable/disable of position independent code"
 	@echo "    POSTFIX=name  == String added to the name of the the build (default: '')"
+	@echo "    DUMP=(1|0)    == Enable/Disable unknown task dumping (default: 0)"
 	@echo "  Install Options:"
 	@echo "    PREFIX=path   == install/uninstall prefix (default: /usr/local)"
 	@echo "    LIBDIR=path   == library prefix (default: PREFIX/lib)"
@@ -295,18 +299,13 @@
 rebuild: clean all
 
 # build dependency files
-CFLAGS += -MD
+CFLAGS += -MD -MP
 -include $(OBJECTS:.o=.d)
-
-CXXFLAGS += $(CFLAGS)
 
 # standard build rules
 $(OBJDIR)/%.o: $(SRCDIR)/%.c
 	$(COMPILE.c) -o $@ $<
 
-$(OBJDIR)/%.o: $(SRCDIR)/%.cpp
-	$(COMPILE.cc) -o $@ $<
-
 $(TARGET): $(OBJECTS)
 	$(LINK.o) $^ $(LOADLIBES) $(LDLIBS) -o $@

=== debian/changelog ===
mupen64plus-rsp-hle (2.5-5) unstable; urgency=medium

  * debian/control
    - Automatically select correct Vcs-Git branch
    - Upgraded to policy 4.4.0, no changes required
    - Switch to debhelper 12
  * debian/rules
    - Allow one to override pkg-config for crossbuilds
  * debian/copyright
    - Update copyright years to 2019

 -- Sven Eckelmann <sven@narfation.org>  Tue, 27 Aug 2019 23:35:53 +0200

mupen64plus-rsp-hle (2.5-4) unstable; urgency=medium

  * debian/control
    - Change Vcs-Git to https://
    - update to debhelper 10
    - Move VCS-* to salsa.debian.org
  * Change debian URLs to https://
  * Sort debian control files with `wrap-and-sort -abst`
  * Upgraded to policy 4.2.1
    - remove get-orig-source rule from debian/rules
  * debian/copyright:
    - Update copyright years
  * debian/rules
    - Remove ddeb migration conflict against pre-stretch package
    - Drop (now default) parameter --parallel for dch

 -- Sven Eckelmann <sven@narfation.org>  Thu, 18 Oct 2018 21:51:43 +0200

mupen64plus-rsp-hle (2.5-3) unstable; urgency=medium

  * debian/control, debian/rules:
     - Drop mupen64plus-rsp-hle-dbg in favor of -dbgsym package
  * Update copyright years in debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 Jan 2016 12:54:04 +0100

mupen64plus-rsp-hle (2.5-2) unstable; urgency=medium

  * debian/control:
    - Change Vcs-Browser to new alioth CGit URL
    - Move Vcs URLs from collab-maint to pkg-games
    - Update upstream URLs
    - Set Maintainer to Debian Games Team

 -- Sven Eckelmann <sven@narfation.org>  Thu, 26 Nov 2015 07:51:23 +0100

mupen64plus-rsp-hle (2.5-1) unstable; urgency=medium

  * New Upstream Version
  * Upload to unstable
  * Upgraded to policy 3.9.6, no changes required
  * debian/copyright:
    - Update years
    - Fix errors in paths to specific files
    - Add new files to debian/copyright

 -- Sven Eckelmann <sven@narfation.org>  Fri, 01 May 2015 16:25:34 +0200

mupen64plus-rsp-hle (2.0+169+g6158876-1) experimental; urgency=medium

  * New Upstream Snapshot from 6158876a2132a2e9adb45d035489938ac9dea5dc

 -- Sven Eckelmann <sven@narfation.org>  Fri, 05 Sep 2014 11:15:24 +0200

mupen64plus-rsp-hle (2.0+158+g889a070-1) experimental; urgency=medium

  * New Upstream Snapshot from 889a0707a5e1ce0197024789a6f7fc1e0a093a99
  * debian/patches:
    - Remove upstream merged jpeg_dispatching_278b0.patch,
      jpeg_memory_alloc_reduce.patch, jpeg_memory_alloc_refactor.patch,
      jpeg_memory_alloc_stack.patch, musyx_initial.patch

 -- Sven Eckelmann <sven@narfation.org>  Sat, 05 Apr 2014 14:23:04 +0200

mupen64plus-rsp-hle (2.0-3) unstable; urgency=medium

  * debian/rules:
    - Use Largefile Support enabled C API

 -- Sven Eckelmann <sven@narfation.org>  Sat, 30 Aug 2014 16:13:03 +0200

mupen64plus-rsp-hle (2.0-2) unstable; urgency=low

  * Upgraded to policy 3.9.5, no changes required
  * debian/patches:
    - Add jpeg_dispatching_278b0.patch, Bottom of the 9th jpeg task dispatching
    - Add jpeg_memory_alloc_reduce.patch, macroblock memory allocation was
      bigger than needed
    - Add jpeg_memory_alloc_stack.patch, Refactor standard macroblock decoder
    - Add jpeg_memory_alloc_refactor.patch, Avoid dynamic memory allocation for
      macroblocks
    - Add musyx_initial.patch, Add initial support for MusyX
  * debian/watch:
    - Change upstream check from bitbucket to github
  * debian/copyright:
    - Change upstream source to github
  * debian/get-orig-source.sh
    - Change upstream repository to github
    - Change SCM from Mercurial to Git
  * Update copyright years in debian/copyright
  * Move keyring for signature verification to new debian/upstream/

 -- Sven Eckelmann <sven@narfation.org>  Sat, 05 Apr 2014 14:13:37 +0200

=== debian/control ===
Source: mupen64plus-rsp-hle
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Sven Eckelmann <sven@narfation.org>,
 Tobias Loose <TobiasLoose@gmx.de>,
Standards-Version: 4.4.0
Homepage: http://mupen64plus.org/
Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-rsp-hle.git -b master
Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-rsp-hle
Build-Depends:
 debhelper-compat (= 12),
 dpkg-dev (>= 1.16.1.1),
 libmupen64plus-dev (>= 1.99.5),

Package: mupen64plus-rsp-hle
Architecture: any-amd64 any-i386
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 mupen64plus-rsp-abi-2,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 mupen64plus-rsp,
Description: high-level rsp emulation for mupen64plus
 N64 Reality Signal Processor function level emulation for graphics plugins
 supporting vertex processing by their own. It supports memory and register
 initialisation, audio and display lists processing including jpeg and mp3
 decoding for common microcodes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

-include /usr/share/dpkg/buildtools.mk

export PKG_CONFIG ?= pkg-config
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
export DEB_CFLAGS_MAINT_APPEND=-flto
export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
MAKEOPTIONS = V=1 UNAME='$(DEB_HOST_ARCH_OS)' HOST_CPU='$(DEB_HOST_GNU_CPU)' APIDIR=/usr/include/mupen64plus/ DEBUG=1 PREFIX=/usr/ LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" PIC=1 OPTFLAGS="-DNDEBUG"

binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
	dh $@ --sourcedirectory="projects/unix"

override_dh_auto_test:
	# otherwise dh_auto_test fails with debhelper 9.20130624

override_dh_auto_clean:
	dh_auto_clean -- $(MAKEOPTIONS)

override_dh_auto_build:
	dh_auto_build -- all $(MAKEOPTIONS)

override_dh_auto_install:
	dh_auto_install -- $(MAKEOPTIONS)

override_dh_installchangelogs:
	dh_installchangelogs RELEASE

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep \
	override_dh_auto_clean override_dh_auto_test override_dh_auto_build override_dh_auto_install override_dh_installchangelogs

=== debian/watch ===
version=3

opts="pgpsigurlmangle=s/$/.asc/" \
 https://github.com/mupen64plus/mupen64plus-rsp-hle/releases \
	/mupen64plus/mupen64plus-rsp-hle/releases/download/[^/]+/mupen64plus-rsp-hle-src-(.*\d).tar.gz

## mupen64plus-rsp-hle 2.5.9%2B32%2Bgca917ce

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,14 @@
 Uploaders:
  Sven Eckelmann <sven@narfation.org>,
  Tobias Loose <TobiasLoose@gmx.de>,
-Standards-Version: 4.4.0
-Homepage: http://mupen64plus.org/
-Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-rsp-hle.git -b master
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: https://mupen64plus.org/
+Vcs-Git: https://salsa.debian.org/games-team/mupen64plus-rsp-hle.git -b debian/unstable
 Vcs-Browser: https://salsa.debian.org/games-team/mupen64plus-rsp-hle
 Build-Depends:
- debhelper-compat (= 12),
- dpkg-dev (>= 1.16.1.1),
- libmupen64plus-dev (>= 1.99.5),
+ debhelper-compat (= 13),
+ libmupen64plus-dev,
 
 Package: mupen64plus-rsp-hle
 Architecture: any-amd64 any-i386

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,10 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
 export DEB_CFLAGS_MAINT_APPEND=-flto
 export DEB_CPPFLAGS_MAINT_APPEND = -D_FILE_OFFSET_BITS=64
-export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
+
+# mupen64plus and its plugins sometimes use signed integer overflows
+# the compiler must not optimize them away due to their "undefined behavior"
+DEB_CFLAGS_MAINT_APPEND=-fno-aggressive-loop-optimizations -fno-strict-overflow
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
